# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from ...valida.control.pendencias import ERP, SUPERVISOR, ERP_SUPERVISOR, PDV, COMANDA, COLETOR


class contrecf_versao_sistema(osv.Model):
    # Tabela que guarda as versoes dos sitemas dos cliente, eh populada via cron no proprio cliente
    # prefixo: ctrvsi

    _inherit = 'contrecf.versao.sistema'

    def name_get(self, cr, user, ids, context=None):
        campos = ['ctrvsi_tipo', 'ctrvsi_versao']
        res = []
        for i in self.read(cr, user, ids, campos, context=context):
            name = '%s - %s' % (dict(self._columns.get('ctrvsi_tipo').selection).get(i.get('ctrvsi_tipo')),
                                i.get('ctrvsi_versao'))
            res.append((i.get('id'), name))

        return res

    def ctrvsi_set_versao_sistemas(self, cr, uid, dados, context=None):
        context = context and context.copy() or {}
        dados_dispositivos = []
        cnpjs = []
        for i in dados:
            cnpjs.append("'%s'" % i.get('cnpj'))
            if i.get('tipo') in (COLETOR, COMANDA):
                dados_dispositivos.append(
                    """(ctrmob_nro_serie = '%s' AND ctrmob_modelo = '%s' AND ctrmob_marca = '%s')""" %
                                          (i.get('serie'), i.get('modelo'), i.get('marca')))

        dict_pessoa = {}
        cr.execute("""SELECT id, cpf_cnpj FROM adm_pessoa WHERE cpf_cnpj IN (%s)""" % ','.join(cnpjs))
        for i in cr.dictfetchall():
            dict_pessoa[i.get('cpf_cnpj')] = i.get('id')

        dict_dipositivos = {}
        if dados_dispositivos:
            cr.execute("""SELECT id,
                                 ctrmob_marca     AS marca,
                                 ctrmob_modelo    AS modelo,
                                 ctrmob_nro_serie AS serie, 
                                 ctrmob_tipo      AS tipo
                          FROM contrecf_mobile 
                          WHERE {cond}
                       """.format(cond='\n                             OR '.join(dados_dispositivos)))
            for i in cr.dictfetchall():
                chave = '%s-%s-%s-%s' % (i.get('marca'), i.get('modelo'), i.get('serie'), i.get('tipo'))
                dict_dipositivos.update({chave: i.get('id')})

        sql = """SELECT cvs.id,
                        ap.cpf_cnpj         AS cnpj,
                        cvs.ctrvsi_tipo     AS tipo,
                        cvs.ctrvsi_caixa    AS caixa,
                        cm.ctrmob_marca     AS marca,
                        cm.ctrmob_modelo    AS modelo,
                        cm.ctrmob_nro_serie AS serie
                        
                 FROM contrecf_versao_sistema AS cvs
                 INNER JOIN adm_pessoa        AS ap  ON ap.id = cvs.ctrvsi_pessoa_id
                 LEFT JOIN contrecf_mobile    AS cm  ON cm.id = cvs.ctrvsi_mobile_id
                 WHERE ap.cpf_cnpj IN ({cnpj})
              """.format(cnpj=",".join(cnpjs))
        cr.execute(sql)
        chaves = {}
        for i in cr.dictfetchall():
            chave = '%s|%s|%s|%s|%s|%s' % (i.get('cnpj'),
                                           i.get('tipo'),
                                           i.get('caixa') or 0,
                                           i.get('marca') or 0,
                                           i.get('modelo') or 0,
                                           i.get('serie') or 0)
            chaves[chave] = i.get('id')

        for i in dados:
            tipo = i.get('tipo')
            chave = '%s|%s|%s|%s|%s|%s' % (i.get('cnpj'),
                                           i.get('tipo'),
                                           i.get('caixa') or 0,
                                           i.get('marca') or 0,
                                           i.get('modelo') or 0,
                                           i.get('serie') or 0)

            if chaves.get(chave):
                self.write(cr, uid, chaves.get(chave), {'ctrvsi_versao': i.get('versao')}, context=context)
            else:
                pessoa_id = dict_pessoa[i.get('cnpj')]
                vals = {'ctrvsi_pessoa_id': pessoa_id,
                        'ctrvsi_tipo': i.get('tipo'),
                        'ctrvsi_versao': i.get('versao'),
                        'ctrvsi_caixa': i.get('caixa') or 0,
                        'ctrvsi_mobile_id': 0}
                if tipo in [COMANDA, COLETOR]:
                    t = i.get('tipo') == COLETOR and '1' or '2'
                    chave_mobile = '%s-%s-%s-%s' % (i.get('marca'), i.get('modelo'), i.get('serie'), t)
                    if not dict_dipositivos.get(chave_mobile):  # dispositivo nao esta cadastrado na SIG
                        continue

                    vals['ctrvsi_mobile_id'] = dict_dipositivos.get(chave_mobile)

                self.create(cr, uid, vals, context=context)