# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from ...valida.control.pendencias import ERP, SUPERVISOR, ERP_SUPERVISOR, PDV, COMANDA, COLETOR
TIPO = [(ERP, 'Erp'),
        (SUPERVISOR, 'Supervisor'),
        (ERP_SUPERVISOR, 'Erp e Supervisor'),
        (PDV, 'Pdv'),
        (COMANDA, 'Comanda'),
        (COLETOR, 'Coletor')]

class contrecf_versao_sistema(osv.Model):
    # Tabela que guarda as versoes dos sitemas dos cliente, eh populada via cron no proprio cliente
    # prefixo: ctrvsi

    _name = 'contrecf.versao.sistema'

    _columns = {
        'write_date': fields.datetime('Data atualizacao'),
        'ctrvsi_pessoa_id': fields.many2one("adm.pessoa", 'Cliente', ondelete="cascade",
                                            select=True, required=True),
        'ctrvsi_tipo': fields.selection(TIPO, 'Tipo do Sistema', select=True, required=True),
        'ctrvsi_versao': fields.char('Versao do Sistema', select=True, size=40),
        'ctrvsi_caixa': fields.integer('Caixa'),
        'ctrvsi_mobile_id': fields.many2one("contrecf.mobile",
                                             'Dispositivo Mobile', ondelete="cascade", select=True),

    }

    _order = 'ctrvsi_pessoa_id, ctrvsi_tipo, ctrvsi_caixa'

