# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.sql import drop_view_if_exists
from datetime import date
from dateutil.relativedelta import relativedelta
from time import strftime

class report_view_help(osv.Model):

    _name = 'report.view.help'
    _inherit = 'report.view.help'

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):

        context = context and context.copy() or {}
        if not args:
            args = []

        if context.get('tipo') == 'fechada':
            sdata = 'date_closed'
        else:
            sdata = 'create_date'

        if context.get('dias') == -1:
            args.append((sdata, '=', (date.today() - relativedelta(days=1)).strftime('%Y-%m-%d')))
        elif context.get('dias') == -2:
            args.append((sdata, '=', (date.today() - relativedelta(days=2)).strftime('%Y-%m-%d')))
        elif context.get('dias') == -3:
            args.append((sdata, '=', (date.today() - relativedelta(days=3)).strftime('%Y-%m-%d')))
        elif context.get('dias') == 0:
            args.append((sdata, '=', strftime('%Y-%m-%d')))
        elif context.get('dias') == 7:
            args.append((sdata, '>=', (date.today() - relativedelta(days=7)).strftime('%Y-%m-%d')))
        elif context.get('dias') == 30:
            args.append((sdata, '>=', (date.today() - relativedelta(days=30)).strftime('%Y-%m-%d')))

        create_date_in_args = filter(lambda i: 'create_date' in i, args)
        if not create_date_in_args:
            args = [('create_date', '=', (date.today() - relativedelta(days=1)).strftime('%Y-%m-%d'))]
        object_in_args = filter(lambda i: 'model' in i, args)
        if not object_in_args:
            ids = self.pool.get('ir.model').search(cr, uid, [('model', '=', 'crm_br.help_desk')], context=context)
            if ids:
                args.append(('object_id', '=', ids[0]))
        res = super(report_view_help, self).search(cr, uid, args, offset, limit, order, context, count)
        return res

    def init(self, cr):
        drop_view_if_exists(cr, "report_view_help")
        cr.execute("""
CREATE OR REPLACE VIEW report_view_help AS (
    SELECT 
        cbc.id, 
        cbc.user_id as crmcal_user_id, 
        cbc.canal_id, 
        cbc.section_id as crmcal_section_id, 
        cbc.categ_id, 
        cbcc.object_id,
        pes.nome AS user_name,  
        ccn.name AS canal_name, 
        cbcc.name AS categ_name, 
        cbcs.name AS sec_name,
        cbc.create_date, 
        cbc.date_closed, 
        cbc.name as descricao,
		1 as atendimentos
    FROM crm_br_case cbc
    LEFT JOIN crm_br_case_log cbc_log 
        ON cbc_log.crmcal_case_id = cbc.id
    LEFT JOIN crm_br_canal ccn 
        ON cbc.canal_id = ccn.id
    LEFT JOIN crm_br_case_categ cbcc 
        ON cbcc.id = cbc.categ_id
    LEFT JOIN res_users ru 
        ON ru.id = cbc.user_id
    LEFT JOIN adm_pessoa pes 
        ON pes.id = ru.pessoa_id
    LEFT JOIN crm_br_case_section cbcs 
        ON cbc.section_id = cbcs.id
    WHERE cbc.create_date > (CURRENT_DATE - INTERVAL '32 days')
)"""
                   )

