# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class valida_dispositivo(osv.Model):
    """
    Tabela de controle de dispositivos
    Prefixo
    valdis_
    """
    _name = 'valida.dispositivo'
    _columns = {
        'name': fields.char('Nome', size=40, help="Nome qualquer que identifique o dispositivo"),
        'create_date': fields.datetime('Data do Cadastro', readonly=True),
        'write_date': fields.datetime('Data Ultima Alteracao', readonly=True),
        'valdis_marca': fields.char('Marca', required=True, size=40),
        'valdis_modelo': fields.char('Modelo', required=True, size=40),
        'valdis_nro_serie': fields.char('Numero de serie', required=True, readonly=True, size=40,
                                        select=True),
        'valdis_responsavel': fields.char('Responsavel', size=60),
        'valdis_licenca': fields.char('Licenca', size=256),
        'valdis_cnpj': fields.char('CNPJ', size=14),
        'valdis_tipo': fields.selection([('1', 'Coletor'),
                                         ('2', 'Comanda')], 'Tipo', readonly=True),
        'valdis_versao': fields.char('Versao', size=40, help="Versao do sistema"),
    }