# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}

        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        title = center_title('', _('Comissao por recebimento'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Comissao por recebimento'))
        listagem.informaTamLinha(160)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=6.25)
        obj_financeiro_titulo = pooler.get_pool(cr.dbname).get('financeiro.titulo')
        obj_financeiro_titulo_baixa = pooler.get_pool(cr.dbname).get('financeiro.titulo.baixa')
        obj_adm_pessoa = pooler.get_pool(cr.dbname).get('adm.pessoa')
        obj_vendas_vendedor = pooler.get_pool(cr.dbname).get('vendas.vendedor')

        tipo_vendedor = datas.get('tipo_vendedor')
        vendedor_id = datas.get('vendedor_id')
        if isinstance(vendedor_id, tuple):
            vendedor_id = vendedor_id[0]
        if isinstance(vendedor_id, list):
            vendedor_id = vendedor_id[0]
        tipo_relatorio = datas.get('tipo_relatorio')
        data_ini = datas.get('data_ini')
        data_fim = datas.get('data_fim')
        dados_financeiro_titulo_vendedor_interno = []
        dados_financeiro_titulo_vendedor_externo = []
        vendedor = None
        tipo = None

        if vendedor_id:
            vendas_vendedor_dados = obj_vendas_vendedor.read(cr, uid, [vendedor_id], ['pessoa_id', 'tipo'],
                                                             context=context)
            if vendas_vendedor_dados:
                for x in vendas_vendedor_dados:
                    vendedor = x.get('pessoa_id')
                    if isinstance(vendedor, tuple):
                        vendedor = vendedor[1]
                    tipo = x.get('tipo')
            vendedor_id = [vendedor_id]
        else:
            vendedor_id = obj_vendas_vendedor.search(cr, uid, [(1, '=', 1)], context=context)
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                                     'vendas.apuracao.comissao.recebimento.osv',
                                                                                     context=context)
        if not isinstance(company_id, list):
            company_id = [company_id]
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id, ['name'],
                                                                               context=context)
        if res_company_dados:
            for x in res_company_dados:
                company = x.get('name')

        lista = []
        lista2 = []
        if tipo_vendedor == 'I':
            for i in vendedor_id:
                tipo_v = obj_vendas_vendedor.read(cr, uid, i, ['tipo'], context=context)
                tipo_v = tipo_v.get('tipo')
                if tipo_v == 'I':
                    lista.append(i)
        elif tipo_vendedor == 'E':
            for i in vendedor_id:
                tipo_v = obj_vendas_vendedor.read(cr, uid, i, ['tipo'], context=context)
                tipo_v = tipo_v.get('tipo')
                if tipo_v == 'E':
                    lista2.append(i)
        else:
            for i in vendedor_id:
                tipo_v = obj_vendas_vendedor.read(cr, uid, i, ['tipo'], context=context)
                tipo_v = tipo_v.get('tipo')
                if tipo_v == 'I':
                    lista.append(i)
                else:
                    lista2.append(i)

        interno_baixa_ids = []
        if tipo_vendedor == "I" or not tipo_vendedor:
            ids_vendedor_interno_financeiro_titulo = obj_financeiro_titulo.search(
                cr, uid, [('vendedor_id', 'in', vendedor_id), ('tipo_titulo', '=', 'R'),
                          ('state', 'in', ('B', 'A')), ('data_pagamento', '>=', data_ini),
                          ('data_pagamento', '<=', data_fim)], context=context)
            if not ids_vendedor_interno_financeiro_titulo:
                ids_vendedor_interno_financeiro_titulo = self.get_titulo_por_data_pagamento(
                    cr, uid, data_ini, data_fim, vendedor_id, context)
            if ids_vendedor_interno_financeiro_titulo:
                dados_financeiro_titulo_vendedor_interno = obj_financeiro_titulo.read(
                    cr, uid, ids_vendedor_interno_financeiro_titulo,
                    ['data_pagamento', 'vr_desconto', 'vr_original', 'documento', 'parcela',
                     'vendedor_id', 'pessoa_id', 'fintit_baixa_ids'], context=context)
                for i in dados_financeiro_titulo_vendedor_interno:
                    interno_baixa_ids += i.get('fintit_baixa_ids')
                    if i.get('pessoa_id'):
                        pessoa_id = i.get('pessoa_id')
                        if isinstance(pessoa_id, tuple):
                            pessoa_id = pessoa_id[0]
                        if not isinstance(pessoa_id, list):
                            pessoa_id = [pessoa_id]
                        dados_adm_pessoa = obj_adm_pessoa.read(cr, uid, pessoa_id, ['codigo', 'nome'], context=context)
                        for y in dados_adm_pessoa:
                            i['codigo'] = y.get('codigo') or ''
                            i['cliente'] = y.get('nome') or ''
                    else:
                        i['codigo'] = ''

        interno_baixa_dict = {}
        interno_baixa_ids = list(set(interno_baixa_ids))
        if interno_baixa_ids:
            financeiro_titulo_baixa_dados = obj_financeiro_titulo_baixa.read(
                cr, uid, interno_baixa_ids, ['valor_pago', 'valor_juros', 'valor_multa',
                                             'valor_desconto', 'fintib_vr_acrescimo', 'titulo_id',
                                             'data_pgto', 'baixa_forma_pgto_ids'],
                load='_classic_write', context=context)
            financeiro_titulo_baixa_dados = filter(
                lambda tb: data_ini <= tb.get('data_pgto') <= data_fim and tb.get(
                    'baixa_forma_pgto_ids'), financeiro_titulo_baixa_dados)
            for baixa in financeiro_titulo_baixa_dados:
                if interno_baixa_dict.get(baixa.get('titulo_id')):
                    interno_baixa_dict[baixa.get('titulo_id')]['valor'] += \
                        baixa.get('valor_pago') - \
                        baixa.get('valor_juros') - baixa.get('valor_multa') - \
                        baixa.get('fintib_vr_acrescimo') + baixa.get('valor_desconto')
                else:
                    interno_baixa_dict.update(
                        {baixa.get('titulo_id'): {
                            'valor': baixa.get('valor_pago') - baixa.get('valor_juros') -
                                     baixa.get('valor_multa') - baixa.get('fintib_vr_acrescimo') +
                                     baixa.get('valor_desconto'),
                            'data': baixa.get('data_pgto')}})

        externo_baixa_ids = []
        if tipo_vendedor == "E" or not tipo_vendedor:
            ids_vendedor_externo_financeiro_titulo = obj_financeiro_titulo.search(
                cr, uid, [('vendedor_externo_id', 'in', vendedor_id), ('tipo_titulo', '=', 'R'),
                          ('state', 'in', ('B', 'A')), ('data_pagamento', '>=', data_ini),
                          ('data_pagamento', '<=', data_fim)], context=context)
            if not ids_vendedor_externo_financeiro_titulo:
                ids_vendedor_externo_financeiro_titulo = self.get_titulo_por_data_pagamento(
                    cr, uid, data_ini, data_fim, vendedor_id, context)
            if ids_vendedor_externo_financeiro_titulo:
                dados_financeiro_titulo_vendedor_externo = obj_financeiro_titulo.read(
                    cr, uid, ids_vendedor_externo_financeiro_titulo,
                    ['data_pagamento', 'vr_desconto', 'vr_original', 'documento', 'parcela',
                     'vendedor_externo_id', 'pessoa_id', 'fintit_baixa_ids'], context=context)
                if dados_financeiro_titulo_vendedor_externo:
                    for i in dados_financeiro_titulo_vendedor_externo:
                        externo_baixa_ids += i.get('fintit_baixa_ids')
                        if i.get('pessoa_id'):
                            pessoa_id = i.get('pessoa_id')
                            if isinstance(pessoa_id, tuple):
                                pessoa_id = pessoa_id[0]
                            if not isinstance(pessoa_id, list):
                                pessoa_id = [pessoa_id]
                            dados_adm_pessoa = obj_adm_pessoa.read(cr, uid, pessoa_id, ['codigo', 'nome'], context=context)
                            for y in dados_adm_pessoa:
                                i['codigo'] = y.get('codigo') or ''
                                i['cliente'] = y.get('nome') or ''
                        else:
                            i['codigo'] = ''

        externo_baixa_dict = {}
        externo_baixa_ids = list(set(externo_baixa_ids))
        if externo_baixa_ids:
            financeiro_titulo_baixa_dados = obj_financeiro_titulo_baixa.read(
                cr, uid, externo_baixa_ids, ['valor_pago', 'valor_juros', 'valor_multa',
                                             'valor_desconto', 'fintib_vr_acrescimo', 'titulo_id',
                                             'data_pgto', 'baixa_forma_pgto_ids'],
                load='_classic_write', context=context)
            financeiro_titulo_baixa_dados = filter(
                lambda tb: data_ini <= tb.get('data_pgto') <= data_fim and tb.get(
                    'baixa_forma_pgto_ids'), financeiro_titulo_baixa_dados)
            for baixa in financeiro_titulo_baixa_dados:
                if externo_baixa_dict.get(baixa.get('titulo_id')):
                    externo_baixa_dict[baixa.get('titulo_id')]['valor'] += \
                        baixa.get('valor_pago') - \
                        baixa.get('valor_juros') - baixa.get('valor_multa') - \
                        baixa.get('fintib_vr_acrescimo') + baixa.get('valor_desconto')
                else:
                    externo_baixa_dict.update(
                        {baixa.get('titulo_id'): {
                            'valor': baixa.get('valor_pago') - baixa.get('valor_juros') -
                                     baixa.get('valor_multa') - baixa.get('fintib_vr_acrescimo') +
                                     baixa.get('valor_desconto'),
                            'data': baixa.get('data_pgto')}})

        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, company, 'Pagina: {{ Page }} ')
        data_ini_editada = time.strftime("%d/%m/%Y", time.strptime(data_ini, "%Y-%m-%d"))
        data_fim_editada = time.strftime("%d/%m/%Y", time.strptime(data_fim, "%Y-%m-%d"))
        interno_baixa_dict, externo_baixa_dict = pooler.get_pool(cr.dbname).get(
            'vendas.apuracao.comissao.recebimento.osv').get_comissao_recebimento(
            cr, uid, interno_baixa_dict, externo_baixa_dict, context)
        nf_ids = []
        if interno_baixa_dict.get('nf_ids'):
            nf_ids.extend(interno_baixa_dict.get('nf_ids'))
        if externo_baixa_dict.get('nf_ids'):
            nf_ids.extend(externo_baixa_dict.get('nf_ids'))

        # notas a vista que tem vendedor mas nao tem titulo
        comissao_sem_titulo = pooler.get_pool(cr.dbname).get(
        'vendas.apuracao.comissao.recebimento.osv').get_comissao_sem_titutlo(cr, data_ini, data_fim, nf_ids)

        # titulos que possuem nota e nao possuem vendedor
        comissao_tit_sem_vendedor = self.get_comissao_tit_sem_vendedor(cr, data_ini, data_fim)

        if tipo_relatorio == "A":
            cab_analitico =  _('     DOCUMENTO         |    DATA    |  CODIGO   '
                               '|                      CLIENTE                      '
                               '|     VALOR TITULO    |   DESCONTO    | COMISSAO |')
            if lista or tipo == "I":
                if tipo:
                    lista = vendedor_id
                for i in lista:
                    vendedor_dados = obj_vendas_vendedor.read(cr, uid, [i], ['pessoa_id'], context=context)
                    for x in vendedor_dados:
                        vendedor = x.get('pessoa_id')
                    if isinstance(vendedor, tuple):
                        vendedor = vendedor[1]
                    listagem.informaCab('' + title)
                    listagem.informaCab('')
                    listagem.informaCab('')
                    listagem.informaCab('' + docs)
                    listagem.informaCab('  ')
                    listagem.informaCab(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.informaCab(cab_analitico)
                    listagem.informaCab(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.imprimeLinha('')
                    listagem.imprimeLinha(
                        '             ' + _('Periodo: ') + data_ini_editada + _(' a ') + data_fim_editada + '          ' + _(
                            'Vendedor: ') + vendedor)
                    listagem.imprimeLinha('')
                    listagem.rodapePadrao()
                    l = []
                    total_titulos = []
                    total_valor = []
                    total_desconto = []
                    total_comissao = []
                    if comissao_sem_titulo.get(i):
                        for comissao in comissao_sem_titulo.get(i):
                            vals = {'pessoa_id': False,
                                    'data_pagamento': False,
                                    'fintit_baixa_ids': [],
                                    'vr_desconto': 0.0,
                                    'parcela': comissao.get('serie_nf'),
                                    'vr_original': 0,
                                    'cliente': '',
                                    'vendedor_id': (i, ''),
                                    'codigo': False,
                                    'id': False,
                                    'documento': comissao.get('numero_nf'),
                                    'valor': comissao.get('total_nf'),
                                    'data': comissao.get('data')[:10],
                                    'vr_comissao': comissao.get('vr_comissao'),
                                    'comissao_sem_titulo': True}

                            dados_financeiro_titulo_vendedor_interno.append(vals)
                    if comissao_tit_sem_vendedor.get(i):
                        for comissao in comissao_tit_sem_vendedor.get(i):
                            vals = {'vr_desconto': 0.0,
                                    'parcela': comissao.get('parcela'),
                                    'cliente': comissao.get('cliente'),
                                    'vendedor_id': (i, ''),
                                    'codigo': comissao.get('codigo'),
                                    'id': comissao.get('titulo_id'),
                                    'documento': comissao.get('documento'),
                                    'valor': comissao.get('valor'),
                                    'data': comissao.get('data')[:10],
                                    'vr_comissao': comissao.get('vr_comissao'),
                                    'comissao_sem_titulo': True}
                            dados_financeiro_titulo_vendedor_interno.append(vals)

                    for x in dados_financeiro_titulo_vendedor_interno:
                        if x.get('vendedor_id'):
                            vend_id = x.get('vendedor_id')
                            if isinstance(vend_id, tuple):
                                vend_id = vend_id[0]
                            if vend_id == i:
                                if x.get('documento'):
                                    l.append(x['documento'])

                                # salta o titulo caso nao tenha baixa nenhuma
                                if not interno_baixa_dict.get(x.get('id')) and not x.get('comissao_sem_titulo'):
                                    continue

                                strDocumento = (x.get('documento') and '%s/%s' % (x['documento'], x['parcela'])) or ''
                                linha = formataString(strDocumento, 15, ' ', 'D', 'N', 'S') + ''
                                linha += ' '
                                linha += formataString('', 6, ' ', 'D', 'N', 'S') + '|'
                                linha += ' '
                                data = x.get('data') or (interno_baixa_dict.get(x.get('id')) or {}).get('data')
                                linha += formataString(
                                    time.strftime("%d/%m/%Y", time.strptime(data, "%Y-%m-%d")), 11, ' ', 'D', 'N',
                                    'S') + '|'
                                linha += ' '
                                linha += formataString(x.get('codigo') or '', 10, ' ', 'D', 'N', 'S') + '|'
                                linha += ' '
                                linha += formataString(x.get('cliente').replace('\t', '') or '',
                                                       50, ' ', 'E', 'N', 'S') + '|'
                                linha += ' '
                                valor = x.get('valor') or (interno_baixa_dict.get(x.get('id')) or {}).get('valor')
                                linha += formataString(getNumeroEditado(valor or 0.0), 20,
                                    ' ', 'E', 'N', 'S') + '|'
                                linha += ' '
                                linha += formataString(getNumeroEditado(x.get('vr_desconto') or 0.0), 14, ' ', 'E', 'N',
                                                       'S') + '|'
                                linha += ' '
                                vr_comissao = x.get('vr_comissao') or (interno_baixa_dict.get(x.get('id')) or {}).get('vr_comissao')
                                vr_comissao = getNumeroEditado(vr_comissao or 0.0, 2)
                                linha += formataString(vr_comissao, 9, ' ', 'E', 'N',
                                    'S') + '|'
                                linha += ' '
                                listagem.imprimeLinha('|' + linha)
                                total_titulos.append(1)
                                total_valor.append(valor or 0.0)
                                total_comissao.append(float(vr_comissao.replace('.', '').replace(',', '.')) or 0.0)
                                total_desconto.append(x.get('vr_desconto'))

                    # Resumo dos títulos para esse vendedor
                    listagem.imprimeLinha(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    linha = '|TOTAL: ---->'
                    linha += formataString(str(len(total_titulos)), 10, ' ', 'E', 'N', 'S') + '|'
                    linha += ' ' * 80
                    linha += formataString(getNumeroEditado(sum(total_valor)), 18, ' ', 'E', 'N', 'S') + '|'
                    linha += formataString(getNumeroEditado(sum(total_desconto)), 15, ' ', 'E', 'N', 'S') + '|'
                    linha += formataString(getNumeroEditado(
                        total_comissao and sum(total_comissao) or 0), 10, ' ', 'E', 'N', 'S') + '|'
                    listagem.imprimeLinha(linha)
                    # listagem.imprimeLinha(_('          TOTAL: ---->  ') + str(len(total_titulos)) + '                                                                                               ' + str(sum(total_valor)) + '                    ' + str(sum(total_desconto)))
                    listagem.imprimeLinha(_(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*'))
                    listagem.imprimeLinha(_(
                        '                                                                                                                   ** Sig Informatica LTDA **       '))
                    if not i == lista[-1]:
                        listagem.imprimeLinha('{{ Page }}')
                        listagem.cabecalhos = []
                if lista2 or tipo == "E":
                    listagem.imprimeLinha('{{ Page }}')
                    listagem.cabecalhos = []
            if lista2 or tipo == "E":
                if tipo:
                    lista2 = vendedor_id
                for i in lista2:
                    vendedor_dados = obj_vendas_vendedor.read(cr, uid, [i], ['pessoa_id'], context=context)
                    for x in vendedor_dados:
                        vendedor = x.get('pessoa_id')
                    if isinstance(vendedor, tuple):
                        vendedor = vendedor[1]
                    listagem.informaCab('' + title)
                    listagem.informaCab('')
                    listagem.informaCab('')
                    listagem.informaCab('' + docs)
                    listagem.informaCab('  ')
                    listagem.informaCab(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.informaCab(cab_analitico)
                    listagem.informaCab(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.imprimeLinha('')
                    listagem.imprimeLinha(
                        '             ' + _('Periodo: ') + data_ini_editada + _(' a ') + data_fim_editada + '          ' + _(
                            'Vendedor: ') + vendedor)
                    listagem.imprimeLinha('')
                    listagem.rodapePadrao()
                    l = []
                    total_titulos = []
                    total_valor = []
                    total_desconto = []
                    total_comissao = []
                    if comissao_sem_titulo.get(i):
                        for comissao in comissao_sem_titulo.get(i):
                            vals = {'pessoa_id': False,
                                    'data_pagamento': False,
                                    'fintit_baixa_ids': [],
                                    'vr_desconto': 0.0,
                                    'parcela': 0,
                                    'vr_original': 0,
                                    'cliente': '',
                                    'vendedor_id': (i, ''),
                                    'codigo': False,
                                    'id': False,
                                    'documento': '%s/%s' % (comissao.get('numero_nf'), comissao.get('serie_nf')),
                                    'valor': comissao.get('total_nf'),
                                    'data': comissao.get('data')[:10],
                                    'vr_comissao': comissao.get('vr_comissao'),
                                    'comissao_sem_titulo': True}

                            dados_financeiro_titulo_vendedor_externo.append(vals)

                    if comissao_tit_sem_vendedor.get(i):
                        for comissao in comissao_tit_sem_vendedor.get(i):
                            vals = {'vr_desconto': 0.0,
                                    'parcela': comissao.get('parcela'),
                                    'cliente': comissao.get('cliente'),
                                    'vendedor_id': (i, ''),
                                    'codigo': comissao.get('codigo'),
                                    'id': comissao.get('titulo_id'),
                                    'documento': comissao.get('documento'),
                                    'valor': comissao.get('valor'),
                                    'data': comissao.get('data')[:10],
                                    'vr_comissao': comissao.get('vr_comissao'),
                                    'comissao_sem_titulo': True}
                            dados_financeiro_titulo_vendedor_externo.append(vals)

                    for x in dados_financeiro_titulo_vendedor_externo:
                        if x.get('vendedor_externo_id'):
                            vend_id = x.get('vendedor_externo_id')
                            if isinstance(vend_id, tuple):
                                vend_id = vend_id[0]
                            if vend_id == i:
                                if x.get('documento'):
                                    l.append(x['documento'])

                                # salta o titulo caso nao tenha baixa nenhuma
                                if not externo_baixa_dict.get(x.get('id')) and not x.get('comissao_sem_titulo'):
                                    continue

                                linha = formataString(x.get('documento') or '', 15, ' ', 'D', 'N', 'S') + ''
                                linha += ' '
                                linha += formataString('', 6, ' ', 'D', 'N', 'S') + '|'
                                linha += ' '
                                data = x.get('data') or (externo_baixa_dict.get(x.get('id')) or {}).get('data')
                                linha += formataString(
                                    time.strftime("%d/%m/%Y", time.strptime(data, "%Y-%m-%d")),
                                    11, ' ', 'D', 'N', 'S') + '|'
                                linha += ' '
                                linha += formataString(x.get('codigo') or '', 10, ' ', 'D', 'N', 'S') + '|'
                                linha += ' '
                                linha += formataString(x.get('cliente').replace('\t', ''), 50, ' ',
                                                       'E', 'N', 'S') + '|'
                                linha += ' '
                                valor = x.get('valor') or (externo_baixa_dict.get(x.get('id')) or {}).get('valor')
                                linha += formataString(getNumeroEditado(valor or 0.0), 20,
                                                       ' ', 'E', 'N', 'S') + '|'
                                linha += ' '
                                linha += formataString(
                                    getNumeroEditado(x.get('vr_desconto') or 0.0), 14, ' ', 'E',
                                    'N', 'S') + '|'
                                linha += ' '
                                if l:
                                    if l.count(x.get('documento')) == 1 or l.count(x.get('documento')) == 0:
                                        linha += formataString(getNumeroEditado(
                                            0, 2), 9, ' ', 'E', 'N', 'S') + '|'
                                        linha += ' '
                                        listagem.imprimeLinha('|' + linha)
                                        total_titulos.append(1)
                                        total_valor.append((externo_baixa_dict.get(x.get('id')) or {}).get(
                                            'valor') or 0.0)
                                        total_desconto.append(x.get('vr_desconto'))
                                else:
                                    linha += formataString(getNumeroEditado(
                                        0, 2), 9, ' ', 'E', 'N', 'S') + '|'
                                    linha += ' '
                                    listagem.imprimeLinha('|' + linha)
                                    total_titulos.append(1)
                                    total_valor.append(valor)
                                    total_desconto.append(x.get('vr_desconto'))
                                total_comissao.append(0)
                    listagem.imprimeLinha(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    linha = '|TOTAL: ---->'
                    linha += formataString(str(len(total_titulos)), 10, ' ', 'E', 'N', 'S') + '|'
                    linha += ' ' * 80
                    linha += formataString(getNumeroEditado(sum(total_valor)), 18, ' ', 'E', 'N', 'S') + '|'
                    linha += formataString(getNumeroEditado(sum(total_desconto)), 15, ' ', 'E', 'N', 'S') + '|'
                    linha += formataString(getNumeroEditado(
                        total_comissao and sum(total_comissao) or 0), 10, ' ', 'E', 'N', 'S') + '|'
                    listagem.imprimeLinha(linha)
                    listagem.imprimeLinha(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.imprimeLinha(_(
                        '                                                                                                                   ** Sig Informatica LTDA **       '))
                    if not i == lista2[-1]:
                        listagem.imprimeLinha('{{ Page }}')
                        listagem.cabecalhos = []
            listagem.finalizaImpressao()
            self.obj = external_pdf(pdf_string.getvalue())
            self.obj.render()
            pdf_string.close()
            return (self.obj.pdf, 'pdf')
        if tipo_relatorio == "S":
            cab_sintetico = _('     QUANTIDADE        |    DATA    |  CODIGO   '
                              '|                      CLIENTE                      '
                              '|     VALOR TITULO    |    DESCONTO   | COMISSAO |')
            if lista or tipo == "I":
                d = {}
                for i in lista:
                    if comissao_sem_titulo.get(i):
                        for comissao in comissao_sem_titulo.get(i):
                            vals = {'pessoa_id': False,
                                    'data_pagamento': False,
                                    'fintit_baixa_ids': [],
                                    'vr_desconto': 0.0,
                                    'parcela': 0,
                                    'vr_original': 0,
                                    'cliente': '',
                                    'vendedor_id': (i, ''),
                                    'codigo': False,
                                    'id': False,
                                    'documento': '%s/%s' % (comissao.get('numero_nf'), comissao.get('serie_nf')),
                                    'valor': comissao.get('total_nf'),
                                    'data': comissao.get('data')[:10],
                                    'vr_comissao': comissao.get('vr_comissao'),
                                    'comissao_sem_titulo': True}

                            dados_financeiro_titulo_vendedor_interno.append(vals)

                    if comissao_tit_sem_vendedor.get(i):
                        for comissao in comissao_tit_sem_vendedor.get(i):
                            vals = {'vr_desconto': 0.0,
                                    'parcela': comissao.get('parcela'),
                                    'cliente': comissao.get('cliente'),
                                    'vendedor_id': (i, ''),
                                    'codigo': comissao.get('codigo'),
                                    'id': comissao.get('titulo_id'),
                                    'documento': comissao.get('documento'),
                                    'valor': comissao.get('valor'),
                                    'data': comissao.get('data')[:10],
                                    'vr_comissao': comissao.get('vr_comissao'),
                                    'comissao_sem_titulo': True}
                            dados_financeiro_titulo_vendedor_interno.append(vals)

                for i in dados_financeiro_titulo_vendedor_interno:
                    # salta o titulo caso nao tenha baixa nenhuma
                    if not interno_baixa_dict.get(i.get('id')) and not i.get('comissao_sem_titulo'):
                        continue

                    data = i.get('data') or (interno_baixa_dict.get(i.get('id')) or {}).get('data')
                    indice = time.strftime("%d-%m-%Y", time.strptime(data, "%Y-%m-%d"))
                    valor = i.get('valor') or (interno_baixa_dict.get(i.get('id')) or {}).get('valor') or 0.0
                    if indice in d and indice != '':
                        d[indice] += valor
                    else:
                        d[indice] = valor
                soma_datas_vendedor_interno = []
                for i in d:
                    soma_datas_vendedor_interno.append({'data': i, 'vr_original': d[i]})
                if tipo:
                    lista = vendedor_id
                for i in lista:
                    vendedor_dados = obj_vendas_vendedor.read(cr, uid, [i], ['pessoa_id'], context=context)
                    for x in vendedor_dados:
                        vendedor = x.get('pessoa_id')
                    if isinstance(vendedor, tuple):
                        vendedor = vendedor[1]
                    listagem.informaCab('' + title)
                    listagem.informaCab('')
                    listagem.informaCab('')
                    listagem.informaCab('' + docs)
                    listagem.informaCab('  ')
                    listagem.informaCab(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.informaCab(cab_sintetico)
                    listagem.informaCab(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.imprimeLinha('')
                    listagem.imprimeLinha(
                        '             ' + _('Periodo: ') + data_ini_editada + _(' a ') + data_fim_editada + '          ' + _(
                            'Vendedor: ') + vendedor)
                    listagem.imprimeLinha('')
                    listagem.rodapePadrao()
                    l = []
                    qtd_titulos = []
                    total_titulos = []
                    valor = []
                    total_valor = []
                    desconto = []
                    total_desconto = []
                    total_comissao = []
                    for x in soma_datas_vendedor_interno:
                        qtd_titulos = []
                        valor = []
                        list_comissao = []
                        for v in dados_financeiro_titulo_vendedor_interno:
                            # salta o titulo caso nao tenha baixa nenhuma
                            if not interno_baixa_dict.get(v.get('id')) and not v.get('comissao_sem_titulo'):
                                continue

                            data = v.get('data') or (interno_baixa_dict.get(v.get('id')) or {}).get('data')
                            if x.get('data') == time.strftime("%d-%m-%Y", time.strptime(data, "%Y-%m-%d")) and \
                                            v.get('vendedor_id')[0] == i:
                                valor.append(v.get('valor') or (interno_baixa_dict.get(v.get('id')) or {}).get('valor') or 0.0)
                                desconto.append(v.get('vr_desconto'))
                                if qtd_titulos.count(v.get('documento')) == 0 or v.get('documento') == '':
                                    qtd_titulos.append(v.get('documento'))
                                vr_comissao = (v.get('vr_comissao') or
                                               (interno_baixa_dict.get(v.get('id')) or {}).get('vr_comissao') or 0)
                                vr_comissao = getNumeroEditado(vr_comissao, 2)
                                vr_comissao = float(vr_comissao.replace(',', '.')) or 0.0
                                list_comissao.append(vr_comissao)

                        if qtd_titulos and valor:
                            linha = formataString(str(len(qtd_titulos)), 22, ' ', 'E', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(time.strftime(x.get('data')), 11, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString('', 10, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString('', 50, ' ', 'E', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(getNumeroEditado(sum(valor)), 20, ' ', 'E', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(getNumeroEditado(sum(desconto)), 14, ' ', 'E', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(getNumeroEditado(sum(list_comissao)), 9, ' ',
                                                   'E', 'N', 'S') + '|'
                            linha += ' '
                            listagem.imprimeLinha('|' + linha)
                            total_titulos.append(len(qtd_titulos))
                            total_valor.append(sum(valor))
                            total_desconto.append(sum(desconto))
                            total_comissao.append(sum(list_comissao))
                    listagem.imprimeLinha(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    linha = '|TOTAL: ---->'
                    linha += formataString(str(sum(total_titulos)), 10, ' ', 'E', 'N', 'S') + '|'
                    linha += ' ' * 80
                    linha += formataString(getNumeroEditado(sum(total_valor)), 18, ' ', 'E', 'N', 'S') + '|'
                    linha += formataString(getNumeroEditado(sum(total_desconto)), 15, ' ', 'E', 'N', 'S') + '|'
                    linha += formataString(getNumeroEditado(sum(total_comissao)), 10, ' ', 'E', 'N',
                                           'S') + '|'
                    listagem.imprimeLinha(linha)
                    listagem.imprimeLinha(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.imprimeLinha(_(
                        '                                                                                                                   ** Sig Informatica LTDA **       '))
                    if not i == lista[-1]:
                        listagem.imprimeLinha('{{ Page }}')
                        listagem.cabecalhos = []
                if lista2 or tipo == "E":
                    listagem.imprimeLinha('{{ Page }}')
                    listagem.cabecalhos = []

            if lista2 or tipo == "E":
                d = {}
                for i in lista2:
                    if comissao_sem_titulo.get(i):
                        for comissao in comissao_sem_titulo.get(i):
                            vals = {'pessoa_id': False,
                                    'data_pagamento': False,
                                    'fintit_baixa_ids': [],
                                    'vr_desconto': 0.0,
                                    'parcela': 0,
                                    'vr_original': 0,
                                    'cliente': '',
                                    'vendedor_id': (i, ''),
                                    'codigo': False,
                                    'id': False,
                                    'documento': '%s/%s' % (comissao.get('numero_nf'), comissao.get('serie_nf')),
                                    'valor': comissao.get('total_nf'),
                                    'data': comissao.get('data')[:10],
                                    'vr_comissao': comissao.get('vr_comissao'),
                                    'comissao_sem_titulo': True}

                            dados_financeiro_titulo_vendedor_externo.append(vals)

                    if comissao_tit_sem_vendedor.get(i):
                        for comissao in comissao_tit_sem_vendedor.get(i):
                            vals = {'vr_desconto': 0.0,
                                    'parcela': comissao.get('parcela'),
                                    'cliente': comissao.get('cliente'),
                                    'vendedor_id': (i, ''),
                                    'codigo': comissao.get('codigo'),
                                    'id': comissao.get('titulo_id'),
                                    'documento': comissao.get('documento'),
                                    'valor': comissao.get('valor'),
                                    'data': comissao.get('data')[:10],
                                    'vr_comissao': comissao.get('vr_comissao'),
                                    'comissao_sem_titulo': True}
                            dados_financeiro_titulo_vendedor_externo.append(vals)

                for i in dados_financeiro_titulo_vendedor_externo:
                    if not externo_baixa_dict.get(i.get('id')) and not i.get('comissao_sem_titulo'):
                        continue

                    data = i.get('data') or (externo_baixa_dict.get(i.get('id')) or {}).get('data')
                    indice = time.strftime("%d-%m-%Y", time.strptime(data, "%Y-%m-%d"))
                    valor = i.get('valor') or (externo_baixa_dict.get(i.get('id')) or {}).get('valor') or 0.0
                    if indice in d and indice != '':
                        d[indice] += valor
                    else:
                        d[indice] = valor
                soma_datas_vendedor_externo = []
                for i in d:
                    soma_datas_vendedor_externo.append({'data': i, 'vr_original': d[i]})
                if tipo:
                    lista2 = vendedor_id
                for i in lista2:
                    vendedor_dados = obj_vendas_vendedor.read(cr, uid, [i], ['pessoa_id'], context=context)
                    for x in vendedor_dados:
                        vendedor = x.get('pessoa_id')
                    if isinstance(vendedor, tuple):
                        vendedor = vendedor[1]
                    listagem.informaCab('' + title)
                    listagem.informaCab('')
                    listagem.informaCab('')
                    listagem.informaCab('' + docs)
                    listagem.informaCab('  ')
                    listagem.informaCab(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.informaCab(cab_sintetico)
                    listagem.informaCab(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.imprimeLinha('')
                    listagem.imprimeLinha(
                        '             ' + _('Periodo: ') + data_ini_editada + _(' a ') + data_fim_editada + '          ' + _(
                            'Vendedor: ') + vendedor)
                    listagem.imprimeLinha('')
                    listagem.rodapePadrao()
                    l = []
                    qtd_titulos = []
                    total_titulos = []
                    valor = []
                    total_valor = []
                    desconto = []
                    total_desconto = []
                    total_comissao = []
                    for x in soma_datas_vendedor_externo:
                        qtd_titulos = []
                        valor = []
                        list_comissao = []
                        for v in dados_financeiro_titulo_vendedor_externo:
                            v_externo_id = v.get('vendedor_externo_id') or False
                            if v_externo_id and isinstance(v_externo_id, (list, tuple)):
                                v_externo_id = v_externo_id[0]
                            if not externo_baixa_dict.get(v.get('id')) and not v.get('comissao_sem_titulo'):
                                continue

                            data = v.get('data') or (externo_baixa_dict.get(v.get('id')) or {}).get('data')
                            if x.get('data') == time.strftime("%d-%m-%Y", time.strptime(
                                    data, "%Y-%m-%d")) and v_externo_id == i:
                                valor.append(v.get('valor') or
                                             (externo_baixa_dict.get(v.get('id')) or {}).get('valor') or 0.0)
                                desconto.append(v.get('vr_desconto'))
                                if qtd_titulos.count(v.get('documento')) == 0 or v.get('documento') == '':
                                    qtd_titulos.append(v.get('documento'))
                                list_comissao.append(0)
                        if qtd_titulos and valor:
                            linha = formataString(str(len(qtd_titulos)), 22, ' ', 'E', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(time.strftime(x.get('data')), 11, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString('', 10, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString('', 50, ' ', 'E', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(getNumeroEditado(sum(valor)), 18, ' ', 'E', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(getNumeroEditado(sum(desconto)), 16, ' ', 'E', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(getNumeroEditado(sum(list_comissao)), 9, ' ',
                                                   'E', 'N', 'S') + '|'
                            linha += ' '
                            listagem.imprimeLinha('|' + linha)
                            total_titulos.append(len(qtd_titulos))
                            total_valor.append(sum(valor))
                            total_desconto.append(sum(desconto))
                            total_comissao.append(sum(list_comissao))
                    listagem.imprimeLinha(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    linha = '|TOTAL: ---->'
                    linha += formataString(str(sum(total_titulos)), 10, ' ', 'E', 'N', 'S') + '|'
                    linha += ' ' * 80
                    linha += formataString(getNumeroEditado(sum(total_valor)), 18, ' ', 'E', 'N', 'S') + '|'
                    linha += formataString(getNumeroEditado(sum(total_desconto)), 15, ' ', 'E', 'N', 'S') + '|'
                    linha += formataString(getNumeroEditado(sum(total_comissao)), 10, ' ', 'E', 'N',
                                           'S') + '|'
                    listagem.imprimeLinha(linha)
                    listagem.imprimeLinha(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.imprimeLinha(_(
                        '                                                                                                                   ** Sig Informatica LTDA **       '))
                    if not i == lista2[-1]:
                        listagem.imprimeLinha('{{ Page }}')
                        listagem.cabecalhos = []

            listagem.finalizaImpressao()
            self.obj = external_pdf(pdf_string.getvalue())
            self.obj.render()
            pdf_string.close()
            return (self.obj.pdf, 'pdf')

    def get_comissao_tit_sem_vendedor(self, cr, data_ini, data_fim):
        sql = """
                SELECT ft.id AS titulo_id,
                       ft.documento,
                       ft.parcela,
                       fn.numero_nf,
                       fn.serie_nf,
                       ftb.data_pgto AS data,
                       emi.vendedor_id,
                       SUM(emi.estmvi_vr_comissao)  AS vr_comissao,
                       COALESCE(fn.vr_total_nf , 0) AS total_nf,
                       ap.codigo,
                       ap.nome AS cliente
                       
                FROM financeiro_titulo            AS ft
                LEFT JOIN financeiro_titulo_baixa AS ftb ON ftb.titulo_id = ft.id
                LEFT JOIN financeiro_fatura       AS ff ON ff.id = ft.fatura_id
                LEFT JOIN fiscal_nf_capa          AS fn ON fn.id = ff.nf_id
                LEFT JOIN estoque_movimento_itens AS emi ON emi.nf_id = fn.id 	
	            LEFT JOIN adm_pessoa              AS ap  ON ap.id = fn.destinatario_id 
                WHERE ftb.data_pgto >= '{data_ini}'
                  AND ftb.data_pgto <= '{data_fim}'
                  AND emi.estmvi_vr_comissao > 0
                  AND ft.vendedor_id IS NULL
                  AND ft.vendedor_externo_id IS NULL
                  AND ff.nf_id IS NOT NULL   
                GROUP BY ft.id, ft.documento, fn.id, emi.vendedor_id, fn.vr_total_nf,
                         ap.codigo, ap.nome, ftb.data_pgto
              """.format(data_ini=data_ini, data_fim=data_fim)
        cr.execute(sql)
        dados = cr.dictfetchall()
        titulo_ids = []
        for i in dados:
            titulo_ids.append('%s' % i.get('titulo_id'))

        sql = """
		  SELECT ft.id, 
				 SUM(ftb.valor_pago - COALESCE(ftb.valor_juros, 0)
					                - COALESCE(ftb.valor_multa, 0)
						  			+ COALESCE(ftb.valor_desconto, 0)) AS total_pagamento
		  FROM financeiro_titulo            AS ft
		  LEFT JOIN financeiro_titulo_baixa AS ftb ON ftb.titulo_id = ft.id
		  WHERE ft.id IN ({titulo_ids})
				AND ftb.data_pgto >= '{data_ini}'
                AND ftb.data_pgto <= '{data_fim}'
		  GROUP BY ft.id
        """.format(titulo_ids=','.join(titulo_ids), data_ini=data_ini, data_fim=data_fim)
        cr.execute(sql)
        pagamentos = {}
        for i in cr.dictfetchall():
            pagamentos[i.get('id')] = i.get('total_pagamento')

        res = {}
        for i in dados:
            vr_pgto = pagamentos.get(i.get('titulo_id'))
            total_nota = i.get('total_nf')
            # a comissao eh proporcional ao total do pagamento em relacao ao valor da nota
            comissao = (vr_pgto / total_nota) * i.get('vr_comissao')
            i['vr_comissao'] = comissao
            i['valor'] = vr_pgto
            vendedor_id = i.get('vendedor_id')
            if not res.get(vendedor_id):
                res[vendedor_id] = [i]
            else:
                res[vendedor_id].append(i)

        return res

    def get_titulo_por_data_pagamento(self, cr, uid, data_ini, data_fim, vendedor_id, context=None):
        context = context and context.copy() or {}
        obj_financeiro_titulo = pooler.get_pool(cr.dbname).get('financeiro.titulo')
        obj_financeiro_titulo_baixa = pooler.get_pool(cr.dbname).get('financeiro.titulo.baixa')
        titulo_baixa_ids = obj_financeiro_titulo_baixa.search(
            cr, uid, [('data_pgto', '>=', data_ini), ('data_pgto', '<=', data_fim)],
            context=context)
        if not titulo_baixa_ids:
            return []
        titulo_baixa_dados = obj_financeiro_titulo_baixa.read(
            cr, uid, titulo_baixa_ids, ['titulo_id'], context, '_classic_write')
        titulo_ids = map(lambda ft: ft.get('titulo_id'), titulo_baixa_dados)
        return obj_financeiro_titulo.search(
            cr, uid, [('vendedor_id', 'in', vendedor_id), ('tipo_titulo', '=', 'R'),
                      ('state', 'in', ('B', 'A')), ('id', 'in', titulo_ids)], context=context)


report_custom('report.vendas_apuracao_comissao_recebimento')


class vendas_apuracao_comissao_recebimento_osv(osv.TransientModel):
    _name = 'vendas.apuracao.comissao.recebimento.osv'
    _columns = {
        'tipo_vendedor': fields.selection([('E', 'Externo'), ('I', 'Interno')], 'Tipo de Vendedor'),
        'vendedor_id': fields.many2one('vendas.vendedor', 'Vendedor'),
        'tipo_relatorio': fields.selection([('A', 'Analitico'), ('S', 'Sintetico')], 'Tipo listagem', required='1'),
        'data_ini': fields.date('Data inicial', required='1'),
        'data_fim': fields.date('Data final', required='1')
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vendas_apuracao_comissao_recebimento_osv_dados = self.read(cr, uid, ids, [], context=context)
        obj_vendas_vendedor = self.pool.get('vendas.vendedor')
        for x in vendas_apuracao_comissao_recebimento_osv_dados:
            if x.get('data_ini') > x.get('data_fim'):
                raise osv.except_osv(_('Atencao'), _('Data inicial nao pode ser maior que a data '
                                                     'final'))
            # TODO: Hoje a view não limpa o campo vendedor_id ao mudar o campo tipo_vendedor.
            # Talvez a melhor forma de tratar fosse via onchange, mas como é um caso pontual, e o único efeito prático
            # é limpar o campo, vou fazer manualmente.
            if (not x.get('tipo_vendedor')) and (x.get('vendedor_id')):
                x['vendedor_id'] = False
            if not x.get('vendedor_id'):
                vendedor_ids = obj_vendas_vendedor.search(cr, uid, [(1, '=', 1)], context=context)
                if not vendedor_ids:
                    raise osv.except_osv(_('Atencao'), _('Nao ha vendedor cadastrado'))
            datas = {
                'tipo_vendedor': x.get('tipo_vendedor'),
                'vendedor_id': x.get('vendedor_id'),
                'tipo_relatorio': x.get('tipo_relatorio'),
                'data_ini': x.get('data_ini'),
                'data_fim': x.get('data_fim')
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'vendas_apuracao_comissao_recebimento',
            'datas': datas,
        }

    def get_comissao_sem_titutlo(self, cr, data_ini, data_fim, nf_ids):
        # implementado por heranca no fiscal
        pass

    def get_comissao_recebimento(self, cr, uid, interno_baixa_dict, externo_baixa_dict,
                                 context=None):
        """
        O metodo calcula o valor da comissao dos vendedores. Esse valor e proporcional pois e
        baseado no valor ja recebido diante do total do documento.
        Metodo sobrescrito no módulo fiscal e ecf pois no faturamento deles e calculada a comissao.
        :param cr: cursor no banco de dados
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario
        :type uid: int
        :param interno_baixa_dict: dados da identificacao dos titulos e o respectivo valor recebido,
        referente aos vendedores internos
        :type interno_baixa_dict: dict
        :param externo_baixa_dict: dados da identificacao dos titulos e o respectivo valor recebido,
        referente aos vendedores externos
        :type externo_baixa_dict: dict
        :param context: dados contextuais
        :type context: dict
        :return: dados da identificacao do titulo e o respectivo valor da comissao
        :rtype: dict
        """
        return interno_baixa_dict, externo_baixa_dict

    def get_total_vendedor_forma_pagamento(self, cr, uid, data_ini, data_fim, vendedor_ids,
                                           vendedor_externo_ids, baixa_ids, context=None):
        """
        Metodo responsavel pelos dados de valores recebidos na baixa de titulos. Esses valores sao
        proporcionais baseados nas formas de pagamentos utilizadas na baixa de titulos avulsos, com
        vendedor identificado.
        OBS.: METODO SOBRESCRITO NOS MODULOS fiscal e ECF, prevalecendo a hierarquia,
        respectivamente.
        :param cr: cursor no banco de dados
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario
        :type uid: int
        :param data_ini: data inicial do filtro de pesquisa
        :type data_ini: str
        :param data_fim: data final do filtro de pesquisa
        :type data_fim: str
        :param vendedor_ids: identificadores dos vendedores internos, tabela vendas_vendedor
        :type vendedor_ids: list
        :param vendedor_externo_ids: identificadores dos vendedores externos, tabela vendas_vendedor
        :type vendedor_externo_ids: list
        :param baixa_ids: identificadores das baixas de titulos, tabela financeiro_titulo_baixa
        :type baixa_ids: list
        :param context: dados contextuais
        :type context: dict
        :return: dados agrupados por vendedor, forma de pagamento e valores apurados
        :rtype: list
        """
        context = context and context.copy() or {}
        sql = """
            SELECT 
                forma_vendedor_id, 
                sum(vr_desconto) AS vr_desconto, 
                sum(vr_acrescimo_total) AS vr_acrescimo_total,
                sum(vr_bruto) AS vr_bruto, 
                sum(vr_liquido) AS vr_liquido, 
                nome_forma, 
                forma_pagamento_id, 
                nome_vendedor
            FROM (
                SELECT
                    (CASE 
                        WHEN titulo.vendedor_id IS NOT NULL 
                            THEN titulo.vendedor_id 
                        ELSE titulo.vendedor_externo_id 
                    END) AS forma_vendedor_id,
                    (
                        SELECT nome 
                        FROM adm_pessoa 
                        WHERE 
                            id IN (
                                SELECT pessoa_id 
                                FROM vendas_vendedor 
                                WHERE 
                                    CASE 
                                        WHEN titulo.vendedor_id IS NOT NULL 
                                            THEN id = titulo.vendedor_id 
                                        ELSE id = titulo.vendedor_externo_id 
                                    END
                                )
                    ) AS nome_vendedor,
                    round((COALESCE(baixa.valor_desconto, 0) / baixa.valor_pago) * 
                        baixa_forma.valor, 2) AS vr_desconto,
                    ROUND((baixa_forma.valor / baixa.valor_pago) * 
                        (baixa.valor_pago 
                        - COALESCE(baixa.valor_juros, 0) 
                        - COALESCE(baixa.valor_multa, 0)
                        - COALESCE(baixa.fintib_vr_acrescimo, 0) 
                        + COALESCE(baixa.valor_desconto, 0)), 2) AS vr_bruto,
                    baixa_forma.valor AS vr_liquido,
                    COALESCE(baixa.valor_juros, 0) + COALESCE(baixa.valor_multa, 0) 
                        + COALESCE(baixa.fintib_vr_acrescimo, 0) AS vr_acrescimo_total,
                    forma.name AS nome_forma,
                    forma.id AS forma_pagamento_id
                FROM
                    financeiro_titulo_baixa baixa
                INNER JOIN
                    financeiro_titulo titulo ON titulo.id = baixa.titulo_id
                INNER JOIN
                    financeiro_tesouraria_baixa_forma_pgto baixa_forma 
                    ON baixa.id = baixa_forma.tesouraria_baixa_id
                INNER JOIN
                    adm_forma_pgto forma ON forma.id = baixa_forma.forma_pgto_id
                WHERE
                    baixa.id IN ({baixa_ids})
                    AND baixa.data_pgto BETWEEN '{data_ini}' AND '{data_fim}'
                    AND (titulo.vendedor_id IN ({vendedor_ids}) 
                         OR titulo.vendedor_externo_id IN ({vendedor_externo_ids})
                         )
                GROUP BY
                    forma_vendedor_id,
                    forma.id, baixa.id , nome_vendedor, baixa_forma.valor
            ) AS tmp
            GROUP BY
                forma_vendedor_id,
                forma_pagamento_id,
                nome_forma,
                nome_vendedor
        """.format(baixa_ids=baixa_ids and ', '.join(map(lambda b: str(b), baixa_ids)) or '-1',
                   vendedor_ids=vendedor_ids and ', '.join(map(lambda v: str(v), vendedor_ids))
                   or '-1',
                   vendedor_externo_ids=vendedor_externo_ids and ', '.join(map(
                       lambda ve: str(ve), vendedor_externo_ids)) or '-1',
                   data_ini=data_ini,
                   data_fim=data_fim)
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados
